package io.zipcoder.interfaces;

public enum Educator implements Teacher {

    KRIS(1, "Kris Younger"),
    DOLIO(2, "Dolio Durant"),
    FROILAN(3, "Froilan Miranda"),
    NHU(4, "Nhu Ngyuen"),
    WILHEM(5, "Wilhem Alcivar"),
    DOMINIQUE(6, "Dominique Clark"),
    LEON(7, "Leon Hunter");

    private double timeWorked;
    private long id;
    private String name;

    Educator(long id, String name) {
        this.id = id;
        this.name = name;
        this.timeWorked = 0;

    }

    public double getTimeWorked() {
        return timeWorked;
    }

    public long getId() {
        return id;
    }

    public String getName() {
        return name;
    }

    public void teach(Learner student, double numberOfHours) {

        student.learn(numberOfHours);
        timeWorked += numberOfHours;
    }

    public void lecture(Learner[] students, double numberOfHours) {
        double numberOfHoursPerLearner = numberOfHours / students.length;

        for (Learner pupil : students) {
            pupil.learn(numberOfHoursPerLearner);
        }
        timeWorked += numberOfHours;
    }
}
