package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Test;

public class InstructorTest {

    @Test
    public void testImplementation() {
        Instructor testInstructor = new Instructor(1, "bob");

        Assert.assertTrue(testInstructor instanceof Teacher);

    }

    @Test
    public void testInheritance() {
        Instructor testInstructor = new Instructor(1, "Bob");

        Assert.assertTrue(testInstructor instanceof Teacher);

    }

    @Test
    public void testTeach() {
        Instructor testInstructor = new Instructor(1, "Bob");
        Student testLearner = new Student(1, "Bob");

        double expected = 10;
        testInstructor.teach(testLearner, 10.0);
        double actual = testLearner.getTotalStudyTime();

        Assert.assertEquals(expected, actual, 01);
    }

    @Test
    public void testLecture() {
        Instructor testInstructor = new Instructor(1, "bob");
        Student student1 = new Student(1, "Bob");
        Student student2 = new Student(2, "Gob");
        Student student3 = new Student(3, "Slob");

        Student[] students = {student1, student2, student3};
        testInstructor.lecture(students, 15);
        double expected = 15.0;
        double actual = 0.0;
        for (Student pupil : students) {
            actual += pupil.getTotalStudyTime();
        }

        Assert.assertEquals(expected, actual, .01);
    }
}
